//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//+++++     _________            __           __________       __               __    __  __    _________       +++++//
//+++++    |XX|X X XX|           XX          |HH|HHH\HHH\     |XX              |XX|  |XX||XX|  |XX|X X XX|      +++++//
//+++++    |XX|    |XX|         /XX\         |HH|      \HH\   |XX||XX|     |XX||XX|    |XX|    |XX|    |XX|     +++++//
//+++++    |XX|    |XX|        /XXXX\        |HH|       |HH|  |XX| |XX|   |XX| |XX|    |XX|    |XX|    |XX|     +++++//
//+++++    |XX|   |XX|        /XX/\XX\       |HH|       |HH|  |XX|  |XX| |XX|  |XX|    |XX|    |XX|   |XX|      +++++//
//+++++    |XX|X X X|        /XX/  \XX\      |HH|       |HH|  |XX|     |XX|    |XX|    |XX|    |XX|X X X|       +++++//
//+++++    |XX|  \XX\       /XXXXXXXXXX\     |HH|       |HH|  |XX|             |XX|    |XX|    |XX|   \XX\      +++++//
//+++++    |XX|   \XX\     /XX/      \XX\    |HH|      /HH/   |XX|             |XX|    |XX|    |XX|    \XX\     +++++//
//+++++    |XX|    |XX|   /XX/        \XX\   |HH|    /HHH/    |XX|             |XX|    |XX|    |XX|     |XX|    +++++//
//+++++    |XX|    |XX|  /XX/          \XX\  |HHHHHHHHH/      |XX|             |XX|  |XX||XX|  |XX|     |XX|    +++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//++++++++++++++++++++++++++++++++     Создатель графики Максим Дубинов(Makarus)     ++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++     По всем вопросам писать сюда vk.com/id178972344     +++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

#include "mta-helper.fx"

texture screen;
texture screenDull;

float BloomStrength = 1.2;

////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// RADMIR ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

sampler2D SamplerScreen = sampler_state
{
    Texture = (screen);
};

sampler2D SamplerScreenDull = sampler_state
{
    Texture = (screenDull);
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU  = Clamp;
	AddressV  = Clamp;
	SRGBTexture=FALSE;
	MaxMipLevel=0;
	MipMapLodBias=0;	
};

struct VSInput
{
    float3 Position : POSITION0;
    float3 Normal : NORMAL0;
    float2 TexCoord : TEXCOORD0;
};

struct PSInput
{
    float4 Position : POSITION0;
    float2 TexCoord : TEXCOORD0;
};

////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// RADMIR ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

PSInput VertexShaderFunction(VSInput VS)
{
    PSInput PS = (PSInput)0;
    PS.Position = mul(float4(VS.Position, 1), gWorldViewProjection);
    PS.Position.xy*= 1.0;	
    PS.TexCoord = VS.TexCoord;
    return PS;
}

////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// RADMIR ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

float4 PixelShaderFunction(PSInput PS, float2 vPos : VPOS0) : COLOR0
{
    float4 bloom = 0.0;
    float4 screenColor = tex2D(SamplerScreen, PS.TexCoord);		
	float2 uv;	

	float2 screenfact = 0.0001;		   
	float step = (1.0-0.5)*1.2;		   
	screenfact.xy*= step;
	
	float2 dir;
	sincos(42.528, dir.x, dir.y);

	  [fastopt]		
      for (int dx=0; dx<24; dx++)
      { 	
		uv = dir.xy * (dx+1.0);
		dir.xy = mul(dir.xy, float2x2(0.76465, -0.64444, 0.64444, 0.76465));				   		   
		uv/= 0.5;	

		uv*= 4.1;
		uv.xy =(uv.xy*screenfact.xy)+PS.TexCoord.xy;
		float4 tempbloom1 = tex2D(SamplerScreenDull, uv.xy);

		bloom+=tempbloom1;
	}	
           screenColor.rgb+= BloomStrength*(bloom.rgb/24);	   
    return screenColor;
}

////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// RADMIR ////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

technique cam_screen_world_mrt
{
    pass P0
    {
		VertexShader = compile vs_3_0 VertexShaderFunction();
		PixelShader = compile ps_3_0 PixelShaderFunction();	
    }

}

// Fallback
technique fallback
{
    pass P0
    {
        // Just draw normally
    }
}
